using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Design;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using NinjaTrader.Indicator;

namespace DTPOrderBookImbalance.NT7
{
    [Description("DTPOrderBookImbalance ver 1.0.0rc")]
    public class DTPOrderBookImbalance : Indicator
    {
        private int int_0 = 1;
        private double double_0 = 1.2;
        private double double_1 = 1.2;
        private long long_0 = 1000;
        private Color color_0 = Color.Red;
        private Color color_1 = Color.Green;
        private Color color_2 = Color.Yellow;
        private Color color_3 = Color.Cyan;
        private Color color_4 = Color.Black;
        private Color color_5 = Color.Black;
        private Color color_6 = Color.Black;
        private Color color_7 = Color.Black;
        private int int_1 = 50;
        private int int_2 = 10;
        private int int_3 = 7;
        private int int_4 = 100;
        private int int_5 = 180;
        private Color color_8 = Color.Green;
        private Color color_9 = Color.Red;
        private Color color_10 = Color.Green;
        private Color color_11 = Color.Red;
        private Color color_12 = Color.White;
        private Color color_13 = Color.Green;
        private Color color_14 = Color.Red;
        private Font font_0 = new Font("Arial", 8f, FontStyle.Regular);
        private StringFormat stringFormat_0 = new StringFormat(StringFormatFlags.NoWrap);
        private int int_6 = 1000;
        private DateTime dateTime_0 = DateTime.MinValue;
        private DOM dom_0 = new DOM(10);
        private List<DTPOrderBookImbalance.Class3>[] list_0 = new List<DTPOrderBookImbalance.Class3>[2];
        private Brush brush_0;
        private Brush brush_1;
        private Brush brush_2;
        private Brush brush_3;
        private bool bool_0;
        private double double_2;
        private double double_3;
        private const int int_7 = 10;
        private DTPOrderBookImbalance.Class2 class2_0;
        private DTPOrderBookImbalanceForm dtporderBookImbalanceForm_0;
        private ToolStripButton toolStripButton_0;
        private ToolStrip toolStrip_0;
        private ToolStripSeparator toolStripSeparator_0;

        [NinjaTrader.Gui.Design.DisplayName("1.Range")]
        [GridCategory("1.Footprint")]
        [Description("Footprint range bar value")]
        public int FootprintBarRange
        {
            get
            {
                return this.int_2;
            }
            set
            {
                this.int_2 = value;
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("2.Right margin")]
        [Description("Footprint right margin")]
        [GridCategory("1.Footprint")]
        public int FootprintRightMargin
        {
            get
            {
                return this.int_4;
            }
            set
            {
                this.int_4 = value;
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("3.Up bar")]
        [GridCategory("1.Footprint")]
        [Description("Footprint up bar color")]
        public Color FootprintUpColor
        {
            get
            {
                return this.color_8;
            }
            set
            {
                this.color_8 = value;
            }
        }

        [Browsable(false)]
        public string FootprintUpColorSerialize
        {
            get
            {
                return SerializableColor.ToString(this.FootprintUpColor);
            }
            set
            {
                this.FootprintUpColor = SerializableColor.FromString(value);
            }
        }

        [Description("Footprint down bar color")]
        [NinjaTrader.Gui.Design.DisplayName("4.Down bar")]
        [GridCategory("1.Footprint")]
        public Color FootprintDownColor
        {
            get
            {
                return this.color_9;
            }
            set
            {
                this.color_9 = value;
            }
        }

        [Browsable(false)]
        public string FootprintDownColorSerialize
        {
            get
            {
                return SerializableColor.ToString(this.FootprintDownColor);
            }
            set
            {
                this.FootprintDownColor = SerializableColor.FromString(value);
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("5.Bid")]
        [GridCategory("1.Footprint")]
        [Description("Footprint bid color")]
        public Color FootprintBidColor
        {
            get
            {
                return this.color_11;
            }
            set
            {
                this.color_11 = value;
            }
        }

        [Browsable(false)]
        public string FootprintBidColorSerialize
        {
            get
            {
                return SerializableColor.ToString(this.FootprintBidColor);
            }
            set
            {
                this.FootprintBidColor = SerializableColor.FromString(value);
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("6.Ask")]
        [GridCategory("1.Footprint")]
        [Description("Footprint ask color")]
        public Color FootprintAskColor
        {
            get
            {
                return this.color_10;
            }
            set
            {
                this.color_10 = value;
            }
        }

        [Browsable(false)]
        public string FootprintAskColorSerialize
        {
            get
            {
                return SerializableColor.ToString(this.FootprintAskColor);
            }
            set
            {
                this.FootprintAskColor = SerializableColor.FromString(value);
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("7.Text")]
        [GridCategory("1.Footprint")]
        [Description("Footprint text color")]
        public Color FootprintTextColor
        {
            get
            {
                return this.color_12;
            }
            set
            {
                this.color_12 = value;
            }
        }

        [Browsable(false)]
        public string FootprintTextColorSerialize
        {
            get
            {
                return SerializableColor.ToString(this.FootprintTextColor);
            }
            set
            {
                this.FootprintTextColor = SerializableColor.FromString(value);
            }
        }

        [GridCategory("1.Footprint")]
        [Description("Footprint positive Finish/Volume/Delta text color")]
        [NinjaTrader.Gui.Design.DisplayName("8.Positive F/V/D")]
        public Color FootprintTextPositiveColor
        {
            get
            {
                return this.color_13;
            }
            set
            {
                this.color_13 = value;
            }
        }

        [Browsable(false)]
        public string FootprintTextPositiveColorSerialize
        {
            get
            {
                return SerializableColor.ToString(this.FootprintTextPositiveColor);
            }
            set
            {
                this.FootprintTextPositiveColor = SerializableColor.FromString(value);
            }
        }

        [GridCategory("1.Footprint")]
        [NinjaTrader.Gui.Design.DisplayName("9.Negative F/V/D")]
        [Description("Footprint negative Finish/Volume/Delta text color")]
        public Color FootprintTextNegativeColor
        {
            get
            {
                return this.color_14;
            }
            set
            {
                this.color_14 = value;
            }
        }

        [Browsable(false)]
        public string FootprintTextNegativeColorSerialize
        {
            get
            {
                return SerializableColor.ToString(this.FootprintTextNegativeColor);
            }
            set
            {
                this.FootprintTextNegativeColor = SerializableColor.FromString(value);
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("1.Mode")]
        [Description("Calculation mode: 1 - Bid vs Ask; 2 - Bid-Ask")]
        [GridCategory("2.Imbalance")]
        public int Mode
        {
            get
            {
                return this.int_0;
            }
            set
            {
                this.int_0 = Math.Min(Math.Max(1, value), 2);
            }
        }

        [Description("Expected max traded volume")]
        [GridCategory("2.Imbalance")]
        [NinjaTrader.Gui.Design.DisplayName("2.Expected max")]
        public long ExpectedMax
        {
            get
            {
                return this.long_0;
            }
            set
            {
                this.long_0 = Math.Max(1L, value);
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("3.Refresh delay")]
        [Description("Refresh delay in milliseconds")]
        [GridCategory("2.Imbalance")]
        public int RefreshDelay
        {
            get
            {
                return this.int_1;
            }
            set
            {
                this.int_1 = Math.Max(0, value);
            }
        }

        [GridCategory("3.Imbalance Bid vs Ask")]
        [Description("Bid vs Ask limits imbalance ratio")]
        [NinjaTrader.Gui.Design.DisplayName("1.Ratio")]
        public double BidAskT1Ratio
        {
            get
            {
                return this.double_0;
            }
            set
            {
                this.double_0 = Math.Max(1.0, value);
            }
        }

        [Description("")]
        [NinjaTrader.Gui.Design.DisplayName("2.Bid")]
        [GridCategory("3.Imbalance Bid vs Ask")]
        public Color ColorT1Bid
        {
            get
            {
                return this.color_1;
            }
            set
            {
                this.color_1 = value;
            }
        }

        [Browsable(false)]
        public string ColorT1BidSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT1Bid);
            }
            set
            {
                this.ColorT1Bid = SerializableColor.FromString(value);
            }
        }

        [GridCategory("3.Imbalance Bid vs Ask")]
        [Description("")]
        [NinjaTrader.Gui.Design.DisplayName("3.Ask")]
        public Color ColorT1Ask
        {
            get
            {
                return this.color_0;
            }
            set
            {
                this.color_0 = value;
            }
        }

        [Browsable(false)]
        public string ColorT1AskSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT1Ask);
            }
            set
            {
                this.ColorT1Ask = SerializableColor.FromString(value);
            }
        }

        [GridCategory("3.Imbalance Bid vs Ask")]
        [Description("Bid volume text color")]
        [NinjaTrader.Gui.Design.DisplayName("4.Bid text")]
        public Color ColorT1BidText
        {
            get
            {
                return this.color_5;
            }
            set
            {
                this.color_5 = value;
            }
        }

        [Browsable(false)]
        public string ColorBidVolumeTextSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT1BidText);
            }
            set
            {
                this.ColorT1BidText = SerializableColor.FromString(value);
            }
        }

        [Description("Ask volume text color")]
        [GridCategory("3.Imbalance Bid vs Ask")]
        [NinjaTrader.Gui.Design.DisplayName("5.Ask text")]
        public Color ColorT1AskText
        {
            get
            {
                return this.color_4;
            }
            set
            {
                this.color_4 = value;
            }
        }

        [Browsable(false)]
        public string ColorT1AskTextSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT1AskText);
            }
            set
            {
                this.ColorT1AskText = SerializableColor.FromString(value);
            }
        }

        [GridCategory("4.Imbalance Bid / Ask")]
        [Description("Bid vs Ask limits imbalance ratio")]
        [NinjaTrader.Gui.Design.DisplayName("1.Ratio")]
        public double BidAskT2Ratio
        {
            get
            {
                return this.double_1;
            }
            set
            {
                this.double_1 = Math.Max(1.0, value);
            }
        }

        [Description("")]
        [NinjaTrader.Gui.Design.DisplayName("2.Bid")]
        [GridCategory("4.Imbalance Bid / Ask")]
        public Color ColorT2Bid
        {
            get
            {
                return this.color_3;
            }
            set
            {
                this.color_3 = value;
            }
        }

        [Browsable(false)]
        public string colorT2BidSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT2Bid);
            }
            set
            {
                this.ColorT2Bid = SerializableColor.FromString(value);
            }
        }

        [Description("")]
        [GridCategory("4.Imbalance Bid / Ask")]
        [NinjaTrader.Gui.Design.DisplayName("3.Ask")]
        public Color ColorT2Ask
        {
            get
            {
                return this.color_2;
            }
            set
            {
                this.color_2 = value;
            }
        }

        [Browsable(false)]
        public string ColorT2AskSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT2Ask);
            }
            set
            {
                this.ColorT2Ask = SerializableColor.FromString(value);
            }
        }

        [GridCategory("4.Imbalance Bid / Ask")]
        [Description("Bid volume text color")]
        [NinjaTrader.Gui.Design.DisplayName("4.Bid text")]
        public Color ColorT2BidText
        {
            get
            {
                return this.color_7;
            }
            set
            {
                this.color_7 = value;
            }
        }

        [Browsable(false)]
        public string ColorT2BidTextSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT2BidText);
            }
            set
            {
                this.ColorT2BidText = SerializableColor.FromString(value);
            }
        }

        [NinjaTrader.Gui.Design.DisplayName("5.Ask text")]
        [Description("Ask volume text color")]
        [GridCategory("4.Imbalance Bid / Ask")]
        public Color ColorT2AskText
        {
            get
            {
                return this.color_6;
            }
            set
            {
                this.color_6 = value;
            }
        }

        [Browsable(false)]
        public string ColorT2AskTextSerialize
        {
            get
            {
                return SerializableColor.ToString(this.ColorT2AskText);
            }
            set
            {
                this.ColorT2AskText = SerializableColor.FromString(value);
            }
        }

        protected override void Initialize()
        {
            this.Overlay = true;
            this.stringFormat_0.Alignment = StringAlignment.Near;
            this.stringFormat_0.LineAlignment = StringAlignment.Center;
            this.brush_0 = (Brush)new SolidBrush(this.color_4);
            this.brush_1 = (Brush)new SolidBrush(this.color_5);
            this.brush_2 = (Brush)new SolidBrush(this.color_6);
            this.brush_3 = (Brush)new SolidBrush(this.color_7);
            this.list_0[0] = new List<DTPOrderBookImbalance.Class3>();
            this.list_0[1] = new List<DTPOrderBookImbalance.Class3>();
            this.dom_0.Initialize(this);
            //this.LogLevel = 6;
        }

        protected override void OnStartUp()
        {
            this.CalculateOnBarClose = false;
            this.ChartControl.ChartPanel.MouseDown += new MouseEventHandler(this.method_0);
            this.class2_0 = new DTPOrderBookImbalance.Class2(this, this.int_2, this.int_3, this.int_5, this.int_4, this.color_8, this.color_9, this.color_10, this.color_11, this.color_12, this.color_13, this.color_14);
            if (this.ChartControl == null)
                return;
            Control[] controlArray = this.ChartControl.Controls.Find("tsrTool", false);
            if (controlArray.Length != 0)
            {
                this.toolStrip_0 = (ToolStrip)controlArray[0];
                this.toolStripSeparator_0 = new ToolStripSeparator();
                this.toolStrip_0.Items.Add((ToolStripItem)this.toolStripSeparator_0);
                this.toolStripButton_0 = new ToolStripButton("DTPOrderBookImbalance");
                this.toolStripButton_0.Text = "DTPOrderBookImbalance parameters";
                //this.toolStripButton_0.Image = (Image)DTPOrderBookImbalanceRes.PropButtonIcon;
                this.toolStripButton_0.ToolTipText = "DTPOrderBookImbalance parameters";
                this.toolStripButton_0.Enabled = true;
                this.toolStrip_0.Items.Add((ToolStripItem)this.toolStripButton_0);
                this.toolStripButton_0.Click += new EventHandler(this.buttonDOMImbalanceParams_Click);
            }
            this.dtporderBookImbalanceForm_0 = new DTPOrderBookImbalanceForm();
        }

        protected override void OnTermination()
        {
            this.font_0.Dispose();
            this.brush_0.Dispose();
            this.brush_1.Dispose();
            this.brush_2.Dispose();
            this.brush_3.Dispose();
            if (this.toolStripButton_0 == null)
                return;
            this.toolStrip_0.Items.Remove((ToolStripItem)this.toolStripButton_0);
            this.toolStrip_0.Items.Remove((ToolStripItem)this.toolStripSeparator_0);
        }

        private void method_0(object sender, MouseEventArgs e)
        {
            if (e.Button != MouseButtons.Left || !this.class2_0.method_6(e.X, e.Y))
                return;
            this.class2_0.method_1();
        }

        protected void buttonDOMImbalanceParams_Click(object sender, EventArgs e)
        {
            this.dtporderBookImbalanceForm_0.Mode = this.Mode;
            this.dtporderBookImbalanceForm_0.BidAskT1Ratio = this.BidAskT1Ratio;
            this.dtporderBookImbalanceForm_0.BidAskT2Ratio = this.BidAskT2Ratio;
            this.dtporderBookImbalanceForm_0.ColorT1Bid = this.ColorT1Bid;
            this.dtporderBookImbalanceForm_0.ColorT1Ask = this.ColorT1Ask;
            this.dtporderBookImbalanceForm_0.ColorT1BidText = this.ColorT1BidText;
            this.dtporderBookImbalanceForm_0.ColorT1AskText = this.ColorT1AskText;
            this.dtporderBookImbalanceForm_0.ColorT2Bid = this.ColorT2Bid;
            this.dtporderBookImbalanceForm_0.ColorT2Ask = this.ColorT2Ask;
            this.dtporderBookImbalanceForm_0.ColorT2BidText = this.ColorT2BidText;
            this.dtporderBookImbalanceForm_0.ColorT2AskText = this.ColorT2AskText;
            if (this.dtporderBookImbalanceForm_0.ShowDialog() != DialogResult.OK)
                return;
            this.Mode = this.dtporderBookImbalanceForm_0.Mode;
            this.BidAskT1Ratio = this.dtporderBookImbalanceForm_0.BidAskT1Ratio;
            this.BidAskT2Ratio = this.dtporderBookImbalanceForm_0.BidAskT2Ratio;
            this.ColorT1Bid = this.dtporderBookImbalanceForm_0.ColorT1Bid;
            this.ColorT1Ask = this.dtporderBookImbalanceForm_0.ColorT1Ask;
            this.ColorT1BidText = this.dtporderBookImbalanceForm_0.ColorT1BidText;
            this.ColorT1AskText = this.dtporderBookImbalanceForm_0.ColorT1AskText;
            this.ColorT2Bid = this.dtporderBookImbalanceForm_0.ColorT2Bid;
            this.ColorT2Ask = this.dtporderBookImbalanceForm_0.ColorT2Ask;
            this.ColorT2BidText = this.dtporderBookImbalanceForm_0.ColorT2BidText;
            this.ColorT2AskText = this.dtporderBookImbalanceForm_0.ColorT2AskText;
        }

        protected override void OnBarUpdate()
        {
        }

        protected override void OnMarketData(MarketDataEventArgs e)
        {
            if (e.MarketDataType == MarketDataType.Ask)
                this.double_2 = e.Price;
            else if (e.MarketDataType == MarketDataType.Bid)
            {
                this.double_3 = e.Price;
            }
            else
            {
                if (e.MarketDataType != MarketDataType.Last)
                    return;
                if (e.Price >= this.double_2 && this.double_2 > 0.0)
                {
                    this.class2_0.method_2(TradeSide.Ask, e);
                }
                else
                {
                    if (this.double_3 <= 0.0)
                        return;
                    this.class2_0.method_2(TradeSide.Bid, e);
                }
            }
        }

        private void method_1(TradeSide tradeSide_0, double double_4)
        {
            foreach (LadderRow ladderRow_0 in this.dom_0.GetRowsByTradeSide(tradeSide_0))
            {
                if ((double)ladderRow_0.Volume > double_4)
                    this.method_5(tradeSide_0, ladderRow_0);
                else
                    this.method_6(tradeSide_0, ladderRow_0);
            }
        }

        private void method_2(TradeSide tradeSide_0)
        {
            foreach (LadderRow ladderRow_0 in this.dom_0.GetRowsByTradeSide(tradeSide_0))
                this.method_6(tradeSide_0, ladderRow_0);
        }

        protected override void OnMarketDepth(MarketDepthEventArgs e)
        {
            if (this.CurrentBar < 1)
                return;
            this.dom_0.OnMarketDepth(e);
            if (!this.dom_0.IsReady())
                return;
            double volume1 = this.dom_0.GetVolume(TradeSide.Ask);
            double volume2 = this.dom_0.GetVolume(TradeSide.Bid);
            double num1 = Math.Max(volume1, volume2);
            double num2 = Math.Min(volume1, volume2);
            if (num2 == 0.0)
                return;
            double num3 = num1 / num2;
            switch (this.int_0)
            {
                case 1:
                    if (num3 >= this.BidAskT1Ratio)
                    {
                        TradeSide tradeSide;
                        double double_4;
                        if (volume1 > volume2)
                        {
                            tradeSide = TradeSide.Ask;
                            double_4 = volume1 / 10.0 * num3;
                        }
                        else
                        {
                            tradeSide = TradeSide.Bid;
                            double_4 = volume2 / 10.0 * num3;
                        }
                        this.method_1(tradeSide, double_4);
                        this.method_2(MZpackHelper.GetOppositeSide(tradeSide));
                        break;
                    }
                    this.method_2(TradeSide.Ask);
                    this.method_2(TradeSide.Bid);
                    break;
                case 2:
                    if (e.MarketDataType == MarketDataType.Ask)
                        this.method_1(TradeSide.Ask, volume1 / 10.0 * this.BidAskT2Ratio);
                    if (e.MarketDataType == MarketDataType.Bid)
                    {
                        this.method_1(TradeSide.Bid, volume2 / 10.0 * this.BidAskT2Ratio);
                        break;
                    }
                    break;
            }
            this.method_3(false, false);
        }

        public override void Plot(Graphics graphics, Rectangle bounds, double min, double max)
        {
            int num = this.int_5 + this.int_4 + 5;
            if (this.ChartControl.BarMarginRight != num)
                this.ChartControl.BarMarginRight = num;
            base.Plot(graphics, bounds, min, max);
            if (this.CurrentBar < 1)
                return;
            SmoothingMode smoothingMode = graphics.SmoothingMode;
            graphics.SmoothingMode = SmoothingMode.AntiAlias;
            this.class2_0.vmethod_1(graphics);
            foreach (DTPOrderBookImbalance.Class3 class3 in this.list_0[1])
            {
                Brush brush = class3.Int32_0 != 1 ? this.brush_2 : this.brush_0;
                Graphics graphics_0 = graphics;
                Font font_0 = this.font_0;
                Brush brush_0 = brush;
                StringFormat stringFormat_0 = this.stringFormat_0;
                class3.method_0(graphics_0, font_0, brush_0, stringFormat_0);
            }
            foreach (DTPOrderBookImbalance.Class3 class3 in this.list_0[0])
            {
                Brush brush = class3.Int32_0 != 1 ? this.brush_3 : this.brush_1;
                Graphics graphics_0 = graphics;
                Font font_0 = this.font_0;
                Brush brush_0 = brush;
                StringFormat stringFormat_0 = this.stringFormat_0;
                class3.method_0(graphics_0, font_0, brush_0, stringFormat_0);
            }
            graphics.SmoothingMode = smoothingMode;
        }

        private void method_3(bool bool_1, bool bool_2)
        {
            if (!(DateTime.Now >= this.dateTime_0.AddMilliseconds((double)this.RefreshDelay)))
                return;
            this.bool_0 = bool_2;
            this.ChartControl.Refresh();
            this.dateTime_0 = DateTime.Now;
        }

        private void method_4(TradeSide tradeSide_0, LadderRow ladderRow_0)
        {
            if (this.list_0[(int)tradeSide_0].Count > this.int_6)
            {
                DTPOrderBookImbalance.Class3 class3 = this.list_0[(int)tradeSide_0][0];
                this.list_0[(int)tradeSide_0].RemoveAt(0);
                class3.Dispose();
            }
            this.list_0[(int)tradeSide_0].Add(new DTPOrderBookImbalance.Class3(this, this.Mode, new MarketDepthEvent(tradeSide_0, this.CurrentBar, ladderRow_0.Price, ladderRow_0.Volume), this.GetBaseColor(tradeSide_0), 0L, this.ExpectedMax)
            {
                Int64_0 = ladderRow_0.Volume
            });
        }

        private void method_5(TradeSide tradeSide_0, LadderRow ladderRow_0)
        {
            DTPOrderBookImbalance.Class3 class3 = this.method_7(this.Mode, tradeSide_0, ladderRow_0.Price);
            if (class3 != null && class3.MarketDepthEvent_0.StopBarIdx >= this.CurrentBar - 1)
            {
                if (class3.MarketDepthEvent_0.StopBarIdx == this.CurrentBar - 1)
                {
                    if (ladderRow_0.Volume == class3.Int64_0)
                        class3.MarketDepthEvent_0.StopBarIdx = this.CurrentBar;
                    else
                        this.method_4(tradeSide_0, ladderRow_0);
                }
                else
                {
                    if (ladderRow_0.Volume == class3.Int64_0)
                        return;
                    if (class3.MarketDepthEvent_0.StartBarIdx == this.CurrentBar)
                    {
                        class3.Int64_0 = ladderRow_0.Volume;
                    }
                    else
                    {
                        class3.MarketDepthEvent_0.StopBarIdx = this.CurrentBar - 1;
                        this.method_4(tradeSide_0, ladderRow_0);
                    }
                }
            }
            else
                this.method_4(tradeSide_0, ladderRow_0);
        }

        private void method_6(TradeSide tradeSide_0, LadderRow ladderRow_0)
        {
            DTPOrderBookImbalance.Class3 class3 = this.method_7(this.Mode, tradeSide_0, ladderRow_0.Price);
            if (class3 == null || class3.MarketDepthEvent_0.StartBarIdx != this.CurrentBar)
                return;
            this.list_0[(int)tradeSide_0].Remove(class3);
            class3.Dispose();
        }

        private DTPOrderBookImbalance.Class3 method_7(int int_8, TradeSide tradeSide_0, double double_4)
        {
            DTPOrderBookImbalance.Class3 class3_1 = (DTPOrderBookImbalance.Class3)null;
            foreach (DTPOrderBookImbalance.Class3 class3_2 in this.list_0[(int)tradeSide_0])
            {
                if (class3_2.MarketDepthEvent_0.Price == double_4 && class3_2.Int32_0 == int_8)
                    class3_1 = class3_2;
            }
            return class3_1;
        }

        protected Color GetBaseColor(TradeSide side)
        {
            if (side == TradeSide.Ask)
                return this.GetAskBaseColor();
            return this.GetBidBaseColor();
        }

        protected Color GetAskBaseColor()
        {
            if (this.int_0 == 1)
                return this.color_0;
            return this.color_2;
        }

        protected Color GetBidBaseColor()
        {
            if (this.int_0 == 1)
                return this.color_1;
            return this.color_3;
        }

        private class Class0
        {
            public double Double_0 { get; private set; }

            public long Int64_0 { get; private set; }

            public DateTime DateTime_0 { get; private set; }

            public Class0()
            {
                this.Int64_0 = 0L;
                this.Double_0 = 0.0;
                this.DateTime_0 = DateTime.MinValue;
            }

            public Class0(MarketDataEventArgs marketDataEventArgs_0)
            {
                this.Int64_0 = marketDataEventArgs_0.Volume;
                this.Double_0 = marketDataEventArgs_0.Price;
                this.DateTime_0 = marketDataEventArgs_0.Time;
            }

            public void method_0(MarketDataEventArgs marketDataEventArgs_0)
            {
                this.Int64_0 = marketDataEventArgs_0.Volume;
                this.Double_0 = marketDataEventArgs_0.Price;
                this.DateTime_0 = marketDataEventArgs_0.Time;
            }

            public void method_1()
            {
                this.Int64_0 = 0L;
                this.Double_0 = 0.0;
                this.DateTime_0 = DateTime.MinValue;
            }
        }

        private class Class1
        {
            protected DTPOrderBookImbalance dtporderBookImbalance_0;
            private SolidBrush solidBrush_0;
            private SolidBrush solidBrush_1;

            public DTPOrderBookImbalance.Class0 Class0_0 { get; private set; }

            public DTPOrderBookImbalance.Class0 Class0_1 { get; private set; }

            public TimeSpan TimeSpan_0
            {
                get
                {
                    return this.Class0_1.DateTime_0.Subtract(this.Class0_0.DateTime_0);
                }
            }

            public double Double_0 { get; private set; }

            public double Double_1 { get; private set; }

            public double Double_2 { get; private set; }

            public double Double_3 { get; private set; }

            public int Int32_0 { get; private set; }

            public int Int32_1 { get; private set; }

            public int Int32_2 { get; private set; }

            public int Int32_3 { get; private set; }

            public Color Color_0
            {
                get
                {
                    return this.solidBrush_0.Color;
                }
                set
                {
                    this.solidBrush_0 = new SolidBrush(value);
                }
            }

            public Color Color_1
            {
                get
                {
                    return this.solidBrush_1.Color;
                }
                set
                {
                    this.solidBrush_1 = new SolidBrush(value);
                }
            }

            public Class1(DTPOrderBookImbalance dtporderBookImbalance_1, int int_4, int int_5, int int_6, int int_7, Color color_0, Color color_1)
            {
                this.dtporderBookImbalance_0 = dtporderBookImbalance_1;
                this.Class0_0 = new DTPOrderBookImbalance.Class0();
                this.Class0_1 = new DTPOrderBookImbalance.Class0();
                double num1 = 0.0;
                double num2 = 0.0;
                this.Double_3 = num1;
                double num3 = num2;
                double num4 = 0.0;
                this.Double_2 = num3;
                double num5 = num4;
                double num6 = 0.0;
                this.Double_1 = num5;
                this.Double_0 = num6;
                this.Int32_0 = int_4;
                this.Int32_2 = int_6;
                this.Int32_1 = int_5;
                this.Int32_3 = int_7;
                this.Color_0 = color_0;
                this.Color_1 = color_1;
            }

            public virtual void vmethod_0()
            {
                this.Class0_0.method_1();
                this.Class0_1.method_1();
                double num1 = 0.0;
                double num2 = 0.0;
                this.Double_3 = num1;
                double num3 = num2;
                double num4 = 0.0;
                this.Double_2 = num3;
                double num5 = num4;
                double num6 = 0.0;
                this.Double_1 = num5;
                this.Double_0 = num6;
            }

            public void method_0(MarketDataEventArgs marketDataEventArgs_0)
            {
                if (this.Class0_0.Double_0 == 0.0)
                    this.Class0_0.method_0(marketDataEventArgs_0);
                this.Class0_1.method_0(marketDataEventArgs_0);
                if (this.Double_0 == 0.0)
                    this.Double_0 = marketDataEventArgs_0.Price;
                this.Double_1 = marketDataEventArgs_0.Price;
                this.Double_2 = Math.Max(this.Double_2, marketDataEventArgs_0.Price);
                this.Double_3 = this.Double_3 != 0.0 ? Math.Min(this.Double_3, marketDataEventArgs_0.Price) : marketDataEventArgs_0.Price;
                if ((this.Double_2 - this.Double_3) / this.dtporderBookImbalance_0.TickSize <= (double)this.Int32_0)
                    return;
                this.vmethod_0();
                this.method_0(marketDataEventArgs_0);
            }

            public virtual void vmethod_1(Graphics graphics_0)
            {
                if (this.Class0_0.Double_0 > 0.0)
                {
                    int num1 = this.dtporderBookImbalance_0.ChartControl.BarWidth + 4;
                    int num2 = this.dtporderBookImbalance_0.ChartControl.GetXByBarIdx(this.dtporderBookImbalance_0.Bars, this.dtporderBookImbalance_0.Bars.GetBar(this.Class0_0.DateTime_0)) - num1 / 2;
                    if (num2 < this.dtporderBookImbalance_0.ChartControl.CanvasRight - this.dtporderBookImbalance_0.ChartControl.BarMarginRight)
                    {
                        Graphics graphics = graphics_0;
                        SolidBrush solidBrush = new SolidBrush(Color.Blue);
                        int x = num2;
                        int y = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.Class0_0.Double_0) - num1 / 2;
                        int num3 = num1;
                        graphics.FillEllipse((Brush)solidBrush, x, y, num3, num3);
                    }
                }
                int num = this.dtporderBookImbalance_0.ChartControl.CanvasRight - this.Int32_3 - this.Int32_2 / 2;
                int ybyValue1 = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.Double_2);
                int ybyValue2 = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.Double_3);
                Pen pen = new Pen(this.dtporderBookImbalance_0.ChartControl.AxisColor, 1f);
                graphics_0.DrawLine(pen, num, ybyValue1, num, ybyValue2);
                if (this.Double_1 == this.Double_0)
                {
                    int ybyValue3 = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.Double_0);
                    graphics_0.DrawLine(pen, num - (this.Int32_1 - 1) / 2, ybyValue3, num + (this.Int32_1 - 1) / 2 + 1, ybyValue3);
                }
                else
                {
                    SolidBrush solidBrush = this.Double_1 > this.Double_0 ? this.solidBrush_0 : this.solidBrush_1;
                    int ybyValue3 = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.Double_0);
                    int ybyValue4 = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.Double_1);
                    int height = Math.Abs(ybyValue3 - ybyValue4) + 1;
                    int y = Math.Min(ybyValue3, ybyValue4);
                    Rectangle rect = new Rectangle(new Point(num - (this.Int32_1 - 1) / 2, y), new Size(this.Int32_1, height));
                    graphics_0.FillRectangle((Brush)solidBrush, rect);
                }
            }
        }

        private class Class2 : DTPOrderBookImbalance.Class1
        {
            private long[] long_3 = new long[2];
            private List<LadderRow>[] list_0 = new List<LadderRow>[2];
            private object object_0 = new object();
            private Font font_0 = new Font("Arial", 8f, FontStyle.Regular);
            private long long_4;
            private long long_5;
            private int int_4;
            private int int_5;
            private int int_6;
            private Color color_0;
            private Color color_1;
            private Color color_2;
            private Rectangle rectangle_0;
            private Brush brush_0;
            private Brush brush_1;
            private Brush brush_2;
            private StringFormat stringFormat_0;
            private StringFormat stringFormat_1;
            private StringFormat stringFormat_2;
            private const int int_7 = 50;
            private const int int_8 = 4;
            private const int int_9 = 100;
            private long long_6;

            public long Int64_0
            {
                get
                {
                    return this.long_3[1] + this.long_3[0];
                }
            }

            public long Int64_1
            {
                get
                {
                    return this.long_3[1] - this.long_3[0];
                }
            }

            public long Int64_2
            {
                get
                {
                    if (this.int_5 < this.int_6)
                        return this.Int64_1 - this.long_5;
                    if (this.int_5 > this.int_6)
                        return this.Int64_1 - this.long_4;
                    return 0;
                }
            }

            public long Int64_3 { get; private set; }

            public long Int64_4 { get; private set; }

            public long Int64_5 { get; private set; }

            public TimeSpan TimeSpan_1 { get; private set; }

            public Class2(DTPOrderBookImbalance dtporderBookImbalance_1, int int_10, int int_11, int int_12, int int_13, Color color_3, Color color_4, Color color_5, Color color_6, Color color_7, Color color_8, Color color_9)
              : base(dtporderBookImbalance_1, int_10, int_11, int_12, int_13, color_3, color_4)
            {
                this.Int64_5 = 0L;
                this.Int64_4 = 0L;
                this.Int64_3 = 0L;
                this.TimeSpan_1 = TimeSpan.Zero;
                this.list_0[1] = new List<LadderRow>();
                this.list_0[0] = new List<LadderRow>();
                this.color_0 = color_5;
                this.color_1 = color_6;
                this.color_2 = color_7;
                this.brush_0 = (Brush)new SolidBrush(color_7);
                this.brush_1 = (Brush)new SolidBrush(color_8);
                this.brush_2 = (Brush)new SolidBrush(color_9);
                this.stringFormat_0 = new StringFormat(StringFormatFlags.NoWrap);
                this.stringFormat_0.Alignment = StringAlignment.Center;
                this.stringFormat_0.LineAlignment = StringAlignment.Center;
                this.stringFormat_1 = new StringFormat(StringFormatFlags.NoWrap);
                this.stringFormat_1.Alignment = StringAlignment.Far;
                this.stringFormat_1.LineAlignment = StringAlignment.Center;
                this.stringFormat_2 = new StringFormat(StringFormatFlags.NoWrap);
                this.stringFormat_2.Alignment = StringAlignment.Near;
                this.stringFormat_2.LineAlignment = StringAlignment.Center;
                this.rectangle_0 = new Rectangle();
            }

            public override void vmethod_0()
            {
                this.TimeSpan_1 = this.TimeSpan_0;
                this.Int64_3 = this.Int64_0;
                this.Int64_4 = this.Int64_1;
                this.Int64_5 = this.Int64_2;
                base.vmethod_0();
                this.int_4 = 0;
                long[] numArray = this.long_3;
                int index = 1;
                this.long_3[0] = 0L;
                long num = 0;
                numArray[index] = num;
                this.list_0[1].Clear();
                this.list_0[0].Clear();
                this.long_6 = 0L;
                this.long_5 = 0L;
                this.long_4 = 0L;
                this.int_6 = 0;
                this.int_5 = 0;
                this.rectangle_0 = new Rectangle();
            }

            public void method_1()
            {
                this.vmethod_0();
                this.Int64_5 = 0L;
                this.Int64_4 = 0L;
                this.Int64_3 = 0L;
                this.TimeSpan_1 = TimeSpan.Zero;
            }

            public void method_2(TradeSide tradeSide_0, MarketDataEventArgs marketDataEventArgs_0)
            {
                lock (this.object_0)
                {
                    this.method_0(marketDataEventArgs_0);
                    this.int_4 = this.int_4 + 1;
                    List<LadderRow> local_1 = this.list_0[(int)tradeSide_0];
                    int local_2 = this.method_5(local_1, marketDataEventArgs_0.Price);
                    if (local_2 >= 0)
                        local_1[local_2].Volume += marketDataEventArgs_0.Volume;
                    else
                        local_1.Add(new LadderRow(marketDataEventArgs_0.Price, marketDataEventArgs_0.Volume, ""));
                    this.long_3[(int)tradeSide_0] += marketDataEventArgs_0.Volume;
                    for (int local_2_1 = 0; local_2_1 < local_1.Count; ++local_2_1)
                        this.long_6 = Math.Max(local_1[local_2_1].Volume, this.long_6);
                    if (this.Int64_1 > this.long_4)
                    {
                        this.long_4 = this.Int64_1;
                        this.int_5 = this.int_4;
                    }
                    else
                    {
                        if (this.Int64_1 >= this.long_5)
                            return;
                        this.long_5 = this.Int64_1;
                        this.int_6 = this.int_4;
                    }
                }
            }

            private Brush method_3(long long_7)
            {
                if (long_7 > 0L)
                    return this.brush_1;
                if (long_7 < 0L)
                    return this.brush_2;
                return this.brush_0;
            }

            public override void vmethod_1(Graphics graphics_0)
            {
                int int_10 = int.MaxValue;
                int int_11 = 0;
                int int_12 = 0;
                lock (this.object_0)
                {
                    base.vmethod_1(graphics_0);
                    this.method_4(graphics_0, TradeSide.Ask, ref int_10, ref int_11, ref int_12);
                    this.method_4(graphics_0, TradeSide.Bid, ref int_10, ref int_11, ref int_12);
                    if (int_11 <= 0)
                        return;
                    int local_4 = this.dtporderBookImbalance_0.ChartControl.CanvasRight - this.Int32_3 - this.Int32_2 + 20;
                    int local_5 = (int)this.font_0.GetHeight(graphics_0) + 2;
                    int local_6 = local_4 + 60 + 8;
                    int local_7 = int_11 + int_12 + 16;
                    Rectangle local_8 = new Rectangle(new Point(local_4, local_7), new Size(60, local_5));
                    graphics_0.DrawString(string.Format("{0}", (object)this.TimeSpan_0), this.font_0, this.brush_0, (RectangleF)local_8, this.stringFormat_1);
                    Rectangle local_8_1 = new Rectangle(new Point(local_6, local_7), new Size(100, local_5));
                    graphics_0.DrawString(string.Format("[ {0} ]", (object)this.TimeSpan_1), this.font_0, this.brush_0, (RectangleF)local_8_1, this.stringFormat_2);
                    int local_7_1 = local_7 + (local_5 + 5);
                    Rectangle local_8_2 = new Rectangle(new Point(local_4, local_7_1), new Size(60, local_5));
                    graphics_0.DrawString(string.Format("F {0}", (object)this.Int64_2), this.font_0, this.method_3(this.Int64_2), (RectangleF)local_8_2, this.stringFormat_1);
                    Rectangle local_8_3 = new Rectangle(new Point(local_6, local_7_1), new Size(100, local_5));
                    graphics_0.DrawString(string.Format("[ {0} ]", (object)this.Int64_5), this.font_0, this.method_3(this.Int64_5), (RectangleF)local_8_3, this.stringFormat_2);
                    int local_7_2 = local_7_1 + (local_5 + 5);
                    Rectangle local_8_4 = new Rectangle(new Point(local_4, local_7_2), new Size(60, local_5));
                    graphics_0.DrawString(string.Format("V {0}", (object)this.Int64_0), this.font_0, this.method_3(this.Int64_0), (RectangleF)local_8_4, this.stringFormat_1);
                    Rectangle local_8_5 = new Rectangle(new Point(local_6, local_7_2), new Size(100, local_5));
                    graphics_0.DrawString(string.Format("[ {0} ]", (object)this.Int64_3), this.font_0, this.method_3(this.Int64_3), (RectangleF)local_8_5, this.stringFormat_2);
                    int local_7_3 = local_7_2 + (local_5 + 5);
                    Rectangle local_8_6 = new Rectangle(new Point(local_4, local_7_3), new Size(60, local_5));
                    graphics_0.DrawString(string.Format("D {0}", (object)this.Int64_1, (object)this.Int64_4), this.font_0, this.method_3(this.Int64_1), (RectangleF)local_8_6, this.stringFormat_1);
                    Rectangle local_8_7 = new Rectangle(new Point(local_6, local_7_3), new Size(100, local_5));
                    graphics_0.DrawString(string.Format("[ {0} ]", (object)this.Int64_4), this.font_0, this.method_3(this.Int64_4), (RectangleF)local_8_7, this.stringFormat_2);
                    int local_7_4 = int_10 - local_5 - 16;
                    int local_4_1 = local_4 + 20;
                    int temp_267 = local_4_1;
                    int temp_268 = local_7_4;
                    int temp_269 = local_5;
                    this.rectangle_0 = new Rectangle(temp_267, temp_268, temp_269, temp_269);
                    Pen local_9 = new Pen(this.dtporderBookImbalance_0.ChartControl.AxisColor, 1f);
                    graphics_0.DrawRectangle(local_9, this.rectangle_0);
                    graphics_0.DrawLine(local_9, this.rectangle_0.Left, this.rectangle_0.Top, this.rectangle_0.Right, this.rectangle_0.Bottom);
                    graphics_0.DrawLine(local_9, this.rectangle_0.Right, this.rectangle_0.Top, this.rectangle_0.Left, this.rectangle_0.Bottom);
                    Rectangle local_8_8 = new Rectangle(local_4_1 + local_5 + 4, local_7_4, 50, local_5);
                    graphics_0.DrawString("CLEAR", this.font_0, this.brush_0, (RectangleF)local_8_8, this.stringFormat_2);
                }
            }

            protected void method_4(Graphics graphics_0, TradeSide tradeSide_0, ref int int_10, ref int int_11, ref int int_12)
            {
                List<LadderRow> list = this.list_0[(int)tradeSide_0];
                int x;
                int num1;
                Color baseColor;
                if (tradeSide_0 == TradeSide.Ask)
                {
                    num1 = x = this.dtporderBookImbalance_0.ChartControl.CanvasRight - this.Int32_3 - this.Int32_2 / 2 + ((this.Int32_1 - 1) / 2 + 1 + 4);
                    baseColor = this.color_0;
                }
                else
                {
                    num1 = this.dtporderBookImbalance_0.ChartControl.CanvasRight - this.Int32_3 - this.Int32_2 / 2 - ((this.Int32_1 - 1) / 2 + 4);
                    x = num1 - 50;
                    baseColor = this.color_1;
                }
                long num2 = Math.Max(this.long_6, 100L);
                int num3 = (int)this.font_0.GetHeight(graphics_0);
                for (int index = 0; index < list.Count; ++index)
                {
                    int ybyValue1 = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, list[index].Price);
                    int ybyValue2 = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, list[index].Price - this.dtporderBookImbalance_0.TickSize);
                    int_12 = ybyValue2 - ybyValue1 - 1;
                    int num4 = ybyValue1 - int_12 / 2;
                    int_11 = Math.Max(num4, int_11);
                    int_10 = Math.Min(num4, int_10);
                    int width = (int)Math.Round((double)list[index].Volume / (double)num2 * 50.0);
                    Rectangle rect = new Rectangle(new Point(tradeSide_0 != TradeSide.Bid ? num1 : num1 - width, num4), new Size(width, int_12));
                    graphics_0.FillRectangle((Brush)new SolidBrush(MZpackHelper.GenVolumeColor(baseColor, 1.0, (double)this.long_6, (double)list[index].Volume)), rect);
                    if (num3 <= int_12 - 2)
                    {
                        rect = new Rectangle(new Point(x, num4), new Size(50, int_12));
                        graphics_0.DrawString(list[index].Volume.ToString(), this.font_0, this.brush_0, (RectangleF)rect, this.stringFormat_0);
                    }
                }
            }

            public int method_5(List<LadderRow> list_1, double double_4)
            {
                for (int index = 0; index < list_1.Count; ++index)
                {
                    if (list_1[index].Price == double_4)
                        return index;
                }
                return -1;
            }

            public bool method_6(int int_10, int int_11)
            {
                return this.rectangle_0.Contains(int_10, int_11);
            }
        }

        private class Class3 : IDisposable
        {
            private DTPOrderBookImbalance dtporderBookImbalance_0;
            private double double_0;
            private Color color_0;
            private long long_0;
            private long long_1;
            private SolidBrush solidBrush_0;
            public bool bool_0;

            public int Int32_0 { get; private set; }

            public MarketDepthEvent MarketDepthEvent_0 { get; private set; }

            public long Int64_0
            {
                get
                {
                    return this.MarketDepthEvent_0.Volume;
                }
                set
                {
                    this.MarketDepthEvent_0.Volume = value;
                    if ((double)value > this.double_0)
                        this.double_0 = (double)value;
                    Color color = MZpackHelper.GenVolumeColor(this.color_0, (double)this.long_0, (double)this.long_1, (double)value);
                    if (this.solidBrush_0 != null)
                    {
                        if (!(color != this.solidBrush_0.Color))
                            return;
                        this.solidBrush_0.Dispose();
                        this.solidBrush_0 = new SolidBrush(color);
                    }
                    else
                        this.solidBrush_0 = new SolidBrush(color);
                }
            }

            public Color Color_0
            {
                get
                {
                    return this.solidBrush_0.Color;
                }
                set
                {
                }
            }

            public Class3(DTPOrderBookImbalance dtporderBookImbalance_1, int int_1, MarketDepthEvent marketDepthEvent_1, Color color_1, long long_2, long long_3)
            {
                this.dtporderBookImbalance_0 = dtporderBookImbalance_1;
                this.Int32_0 = int_1;
                this.MarketDepthEvent_0 = marketDepthEvent_1;
                this.double_0 = 0.0;
                this.bool_0 = true;
                this.color_0 = color_1;
                this.long_0 = long_2;
                this.long_1 = long_3;
                this.solidBrush_0 = (SolidBrush)null;
            }

            public void Dispose()
            {
                this.MarketDepthEvent_0.Dispose();
                this.solidBrush_0.Dispose();
            }

            public void method_0(Graphics graphics_0, Font font_0, Brush brush_0, StringFormat stringFormat_0)
            {
                int num = this.dtporderBookImbalance_0.ChartControl.BarSpace;
                int x = this.dtporderBookImbalance_0.ChartControl.GetXByBarIdx(this.dtporderBookImbalance_0.Bars, this.MarketDepthEvent_0.StartBarIdx) - num / 2;
                if (this.MarketDepthEvent_0.StartBarIdx < this.MarketDepthEvent_0.StopBarIdx)
                    num = this.dtporderBookImbalance_0.ChartControl.GetXByBarIdx(this.dtporderBookImbalance_0.Bars, this.MarketDepthEvent_0.StopBarIdx) - x + num / 2;
                int width = Math.Min(this.dtporderBookImbalance_0.ChartControl.CanvasRight - this.dtporderBookImbalance_0.ChartControl.BarMarginRight, x + num) - x;
                if (width <= 0)
                    return;
                int ybyValue = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.MarketDepthEvent_0.Price);
                int height = this.dtporderBookImbalance_0.ChartControl.GetYByValue(this.dtporderBookImbalance_0.Bars, this.MarketDepthEvent_0.Price - this.dtporderBookImbalance_0.TickSize) - ybyValue - 1;
                Rectangle rect = new Rectangle(x, ybyValue - height / 2, width, height);
                graphics_0.FillRectangle((Brush)this.solidBrush_0, rect);
                if (width < 18)
                    return;
                graphics_0.DrawString(this.Int64_0.ToString(), font_0, brush_0, (RectangleF)rect, stringFormat_0);
            }
        }
    }
    public static class MZpackHelper
    {
        public static byte MinVolumeAlpha = 90;
        public static byte MaxVolumeAlpha = byte.MaxValue;

        public static double GetIfContains(DataSeries Data, int barsAgo)
        {
            if (!Data.ContainsValue(barsAgo))
                return 0.0;
            return Data[barsAgo];
        }

        public static TradeSide GetOppositeSide(TradeSide tradeSide)
        {
            return tradeSide == TradeSide.Ask ? TradeSide.Bid : TradeSide.Ask;
        }

        public static bool Is1TickChart(Period period)
        {
            if (period.Id == PeriodType.Tick)
                return period.Value == 1;
            return false;
        }

        public static Color GenVolumeColor(Color baseColor, double rangeMin, double rangeMax, double volume)
        {
            byte num = 0;
            if (volume > 0.0)
            {
                if (rangeMin > rangeMax || rangeMin == rangeMax)
                    rangeMin = rangeMax - 1.0;
                volume = Math.Max(volume, rangeMin);
                double val2 = Math.Abs((volume - rangeMin) / (rangeMax - rangeMin));
                num = rangeMax > 0.0 ? (byte)Math.Max((double)MZpackHelper.MinVolumeAlpha, Math.Round((double)MZpackHelper.MaxVolumeAlpha * Math.Min(1.0, val2))) : MZpackHelper.MaxVolumeAlpha;
            }
            return Color.FromArgb((int)num, baseColor);
        }

        public static Color GenMinVolumeColor(Color baseColor)
        {
            return Color.FromArgb((int)MZpackHelper.MinVolumeAlpha, baseColor);
        }

        public static Color GenMaxVolumeColor(Color baseColor)
        {
            return Color.FromArgb((int)MZpackHelper.MaxVolumeAlpha, baseColor);
        }
    }

    public class MarketDepthEvent : IDisposable
    {
        public TradeSide Side;
        public int StartBarIdx;
        public int StopBarIdx;
        public double Price;
        public long Volume;

        public MarketDepthEvent(TradeSide tradeSide_0, int int_0, double double_0, long long_0)
        {
            this.Side = tradeSide_0;
            this.StartBarIdx = int_0;
            this.StopBarIdx = int_0;
            this.Price = double_0;
            this.Volume = long_0;
        }

        public void Dispose()
        {
        }
    }

    public class LadderRow
    {
        public string MarketMaker;
        public double Price;
        public long Volume;

        public LadderRow(double double_0, long long_0, string string_0)
        {
            this.MarketMaker = string_0;
            this.Price = double_0;
            this.Volume = long_0;
        }
    }

    public class Volumes
    {
        public DateTime BarTime;
        public long TickVolume;
        public long BarVolume;
        public long CumVolume;
        public long IcebergTickVolume;
        public long IcebergBarVolume;
        public long IcebergCumVolume;
        public long BeforeTickVolume;
        public long AfterTickVolume;

        public Volumes(long long_0, long long_1, long long_2, long long_3, long long_4, long long_5, long long_6, long long_7)
        {
            this.TickVolume = long_0;
            this.BarVolume = long_1;
            this.CumVolume = long_2;
            this.IcebergTickVolume = long_3;
            this.IcebergBarVolume = long_4;
            this.IcebergCumVolume = long_5;
            this.BeforeTickVolume = long_6;
            this.AfterTickVolume = long_7;
        }

        public long GetDisplayVolume(Period period)
        {
            if (MZpackHelper.Is1TickChart(period))
                return this.CumVolume;
            return this.BarVolume;
        }

        public long GetDisplayIcebergVolume(Period period)
        {
            if (MZpackHelper.Is1TickChart(period))
                return this.IcebergCumVolume;
            return this.IcebergBarVolume;
        }

        public void OnNewAskBid(MarketDataEventArgs e)
        {
            this.BeforeTickVolume = this.AfterTickVolume = e.Volume;
            this.Reset();
        }

        public void Reset()
        {
            this.IcebergCumVolume = 0L;
            this.CumVolume = 0L;
            this.IcebergTickVolume = 0L;
            this.TickVolume = 0L;
        }
    }

    public class Squeeze
    {
        private static long long_0;
        public long Id;
        public TradeSide Side;
        public double StartPrice;
        public double StopPrice;
        public DateTime StartTime;
        public DateTime StopTime;
        public long Volume;

        public Squeeze(TradeSide tradeSide_0, double double_0, double double_1, DateTime dateTime_0, DateTime dateTime_1, long long_1)
        {
            ++Squeeze.long_0;
            this.Id = Squeeze.long_0;
            this.Side = tradeSide_0;
            this.StartPrice = double_0;
            this.StopPrice = double_1;
            this.StartTime = dateTime_0;
            this.StopTime = dateTime_1;
            this.Volume = long_1;
        }

        public Squeeze Clone()
        {
            return new Squeeze(this.Side, this.StartPrice, this.StopPrice, this.StartTime, this.StopTime, this.Volume);
        }

        public double GetRange()
        {
            if (this.StopPrice != 0.0 && this.StartPrice != 0.0)
                return Math.Abs(this.StartPrice - this.StopPrice);
            return 0.0;
        }
    }

    public class DOM
    {
        private Indicator indicator_0;
        private int int_0;
        private List<LadderRow> list_0;
        private List<LadderRow> list_1;

        public DOM(int int_1)
        {
            this.int_0 = int_1;
            this.list_0 = new List<LadderRow>();
            this.list_1 = new List<LadderRow>();
        }

        public void Initialize(Indicator indicator)
        {
            this.indicator_0 = indicator;
            for (int index = 0; index < this.int_0; ++index)
                this.list_1.Insert(index, new LadderRow(0.0, 0L, ""));
            for (int index = 0; index < this.int_0; ++index)
                this.list_0.Insert(index, new LadderRow(0.0, 0L, ""));
        }

        public bool IsReady()
        {
            foreach (LadderRow ladderRow in this.list_1)
            {
                if (ladderRow.Price == 0.0)
                    return false;
            }
            foreach (LadderRow ladderRow in this.list_0)
            {
                if (ladderRow.Price == 0.0)
                    return false;
            }
            return true;
        }

        public void OnMarketDepth(MarketDepthEventArgs e)
        {
            List<LadderRow> list1 = (List<LadderRow>)null;
            if (e.MarketDataType == MarketDataType.Ask)
                list1 = this.list_0;
            else if (e.MarketDataType == MarketDataType.Bid)
                list1 = this.list_1;
            if (list1 == null)
                return;
            switch (e.Operation)
            {
                case Operation.Insert:
                    if (e.Position > list1.Count)
                        break;
                    list1.Insert(e.Position, new LadderRow(e.Price, e.Volume, e.MarketMaker));
                    if (list1.Count <= this.int_0)
                        break;
                    List<LadderRow> list2 = list1;
                    int index = list2.Count - 1;
                    list2.RemoveAt(index);
                    break;
                case Operation.Update:
                    if (e.Position >= list1.Count)
                        break;
                    list1[e.Position].MarketMaker = e.MarketMaker;
                    list1[e.Position].Price = e.Price;
                    list1[e.Position].Volume = e.Volume;
                    break;
                case Operation.Remove:
                    if (e.Position >= list1.Count)
                        break;
                    list1.RemoveAt(e.Position);
                    break;
            }
        }

        public void PrintOrderBook()
        {
            this.indicator_0.Print("OrderBook");
            lock (this.list_0)
            {
                for (int local_1 = this.list_0.Count - 1; local_1 >= 0; --local_1)
                    this.indicator_0.Print(string.Format("Ask {0} {1} {2}", (object)local_1.ToString(), (object)this.list_0[local_1].Price.ToString(), (object)this.list_0[local_1].Volume.ToString()));
            }
            lock (this.list_1)
            {
                for (int local_2 = 0; local_2 < this.list_1.Count; ++local_2)
                    this.indicator_0.Print(string.Format("Bid  {0} {1} {2}", (object)local_2.ToString(), (object)this.list_1[local_2].Price.ToString(), (object)this.list_1[local_2].Volume.ToString()));
            }
        }

        public void PrintLadderRows(List<LadderRow> rows)
        {
            for (int index = 0; index < rows.Count; ++index)
                this.indicator_0.Print(string.Format("Price {0} {1}", (object)rows[index].Price.ToString(), (object)rows[index].Volume.ToString()));
        }

        public int GetRowByPrice(List<LadderRow> rows, double rowPrice)
        {
            for (int index = 0; index < rows.Count; ++index)
            {
                if (rows[index].Price == rowPrice)
                    return index;
            }
            return -1;
        }

        public List<LadderRow> GetRowsByTradeSide(TradeSide tradeSide)
        {
            if (tradeSide == TradeSide.Ask)
                return this.list_0;
            if (tradeSide == TradeSide.Bid)
                return this.list_1;
            return (List<LadderRow>)null;
        }

        public static int GetTradeSign(TradeSide side)
        {
            if (side == TradeSide.Ask)
                return 1;
            return side == TradeSide.Bid ? -1 : 0;
        }

        public double GetVolume(TradeSide side)
        {
            List<LadderRow> rowsByTradeSide = this.GetRowsByTradeSide(side);
            if (rowsByTradeSide == null)
                return 0.0;
            lock (rowsByTradeSide)
            {
                double local_2 = 0.0;
                for (int local_3 = 0; local_3 < rowsByTradeSide.Count; ++local_3)
                    local_2 += (double)rowsByTradeSide[local_3].Volume;
                return local_2;
            }
        }

        public long GetVolumeMarketDepth(double rowPrice)
        {
            lock (this.list_0)
            {
                int local_0_1 = this.GetRowByPrice(this.list_0, rowPrice);
                if (local_0_1 > -1)
                    return this.list_0[local_0_1].Volume;
            }
            lock (this.list_1)
            {
                int local_0_2 = this.GetRowByPrice(this.list_1, rowPrice);
                if (local_0_2 > -1)
                    return this.list_1[local_0_2].Volume;
            }
            return 0;
        }

        public TradeSide GetSideMarketDepth(double rowPrice)
        {
            lock (this.list_0)
            {
                if (this.GetRowByPrice(this.list_0, rowPrice) > -1)
                    return TradeSide.Ask;
            }
            lock (this.list_1)
            {
                if (this.GetRowByPrice(this.list_1, rowPrice) > -1)
                    return TradeSide.Bid;
            }
            return TradeSide.Ask;
        }
    }

    public enum TradeSide
    {
        Bid,
        Ask,
        NA,
    }

}
